\ AutoG.fth Taqoz V2.8 Tools


IFDEF *CeTools*	
    \ oldCeTOrg org
    !polls
    1 cogstop
    FORGET *CeTools*  }

pub *CeTools*	PRINT" CeTools AutoG.fth CWE " ;

\ 0 bytes oldCeTOrg

org@ := oriorg
$7a000 := userdata
userdata org

: Variables_Library ; \ { #################################################

\ { Create and Does by Bob Edwards ########################################

--- create new dev with dummy cfa (save ptr to it)
pub CREATE ( -- )
    [C] GRAB
    [C] CREATE: --- Using the next word in the input stream as the name, create a VARIABLE type dictionary entry
    [C] GRAB --- make sure CREATE: has run before anything more
    HERE 2- 0 REG W! --- save the address of the code after DOES> in the REG scratchpad area
;
--- set new cfa to point back to DOES: code (skipped by DOES: itself)
pub DOES> ( -- )
    R> --- the first word location in the new word being defined
    0 REG W@ --- retrieve the address stored on scratchpad
    W! --- set the first word to execute as the address of the code after DOES>
;


{ --- example definition of a new 'array of words' data type - no bounds checking
pre WARRAY
    CREATE ( cnt -- )
    FOR
        0 [C] ||
    NEXT --- Create cnt bytes set to 0
    DOES> ( index -- addr )
        2* R> + --- the address of the first byte + index = the entry reqd
;
--- Create a new array MARRAY1 which can hold 10 word size values
10 WARRAY MYARRAY1
}

\ }

\ { Value variable type ########################################## 
: cells 4* ;

pre cpuVar ( <name> ) \ create private long variable=0 for each cpu
     create 
        8 FOR
            0 [C] ,
        NEXT --- Create 8 longs set to 0
     does> ( -- address )
        R> cogid 4* + 
;

cpuVar toset \ is cleared
 
: to 1 toset ! ; ( Hilfswort fuer Value )
: +to 2 toset ! ; ( Hilfswort fuer Value ==> Addition )

\ Version in Forth
{ 
pre value ( beim Anlegen wird Wert abgelegt, nach to: Wert ueberschreiben, )
    ( +to addieren, sonst wird Wert auf den Stack gelegt )
    create 
    [C] ,
    does> 
        R>
        toset @ 1 = if
            !
            0 toset !
        else 
            toset @ 2 = if
                +!
                0 toset !
            else
                @
            then
        then
; 
}

code (value) ( [newvalue] addr_toset Adress -- ) '\ checks toset, 0: read, 1: store, 2: +=
            rdlong r0,b wz  '\ get toset
    if_z    rdlong b,a  '\ get the value
    if_z    jmp #\@DROP
            cmp r0,#1 wz    '\ check for store
            mov r0,#0   '\ clear toset
            wrlong r0,b
    if_z    wrlong c,a  '\ store the new value
    if_z    jmp #\@3DROP     

            rdlong r1,a  '\ get the oldvalue
            add r1,c     '\ add newvalue
            wrlong r1,a  '\ store the value
            jmp #\@3DROP     
end

pre value ( beim Anlegen wird Wert abgelegt, nach to: Wert ueberschreiben, )
    ( +to addieren, sonst wird Wert auf den Stack gelegt )
    create 
    [C] ,
    does> 
        toset
        R>
        (value)
; 




( 25 value foo )
( foo . )

\ } Value Variable 

: Locals_Library ; ( { simple locals Library ############################ )

( Adapted from: https://atariage.com/forums/topic/273092-forth-local-variables-for-the-common-man/ )
\ Mark Wills: http://turboforth.net/resources/simple_locals.html

\ create locals 100 cells allot ( locals stack )
\ 100 longs locals \ locals lsp ! \ only for cog0 !!!
\ RX Buffers $0007_F500
$7F500 1600 4* - := locals \ $7_E880 200 longs for each cog

cpuVar lsp
: lspInit \ is executed by cog0
    8 for \ all cogs
        i 800 * locals +   
        lsp i 4* + \ store base of stack for all cogs
        !
    next
;
lspInit
        
: >a ( n -- ) lsp @ ! ;
: >b ( n -- ) lsp @ 4 + ! ;
: >c ( n -- ) lsp @ 8 + ! ;
: >d ( n -- ) lsp @ 12 + ! ;
: >e ( n -- ) lsp @ 16 + ! ;
: a> ( -- n ) lsp @ @ ;
: b> ( -- n ) lsp @ 4 + @ ;
: c> ( -- n ) lsp @ 8 + @ ;
: d> ( -- n ) lsp @ 12 + @ ;
: e> ( -- n ) lsp @ 16 + @ ;
: lsp-> ( -- )  lsp @ 5 cells + lsp ! ; ( 6 +to lsp ; )
: <-lsp ( -- )  lsp @ 5 cells - lsp ! ; ( -6 +to lsp ; )

: loc lsp-> nop ; ( put 0 locals into local stack. loc_ geht nicht ! )
: loc_a lsp-> >a ; ( put 1 locals into local stack )
: loc_a_b lsp-> >b >a ; ( put 2 locals into local stack )
: loc_a_b_c lsp-> >c >b >a ; ( put 3 locals into local stack )
: loc_a_b_c_d lsp-> >d >c >b >a ; ( put 4 locals into local stack )
: loc_a_b_c_d_e lsp-> >e >d >c >b >a ; ( put 5 locals into local stack )
: endloc <-lsp ; ( free the local stack )
: testlocal loc_a_b_c ( a b c -- n ) a> b> - c> * endloc ;
( 5 2 7 testlocal . )

\ } Locals

\ } Variables_Library

: MemInfo_Library ; \ { #################################################################

: .cogs \ print the words running in cogs
    8 0 do
        crlf i . space i task w@ cfa>nfa .nfa
    loop
;

: .memscan \ print contents of memory
    crlf ." Memory scan: (1k)"
    $8.0000 0 do
        crlf+ i .l space
        $8000 0 do
            j i + @ dup 
            0 = if ." 0" drop
            else
                $0E0E0E0E = if ." v" \ Video
                else ." X" then
            then
        $400 +loop       
    $8000 +loop
;

: .memo \ print memory information
    .USAGE
    crlf+ ." Code:      " 0 .l ."  to " here .l
    crlf+ ." Words:     " @words .l ."  to " " END" SEARCH 6 + .l
    crlf+ ." Vid 360p:  " BMP .l ."  to " 
        BMP 256 + 1024 + 640 360 * + .l
    crlf+ 
    crlf+ ." Original Data:   " $1800 .l ."  to " oriorg .l
    crlf+ ." User Data:       " userdata .l ."  to " org@ .l    
    crlf+ ." Locals Start:    " locals .l
    crlf+ ." RX Buffer Start: " $7f500 .l
    crlf+ ." SD:              " sdbuf .l ."  to End"
    .memscan
;

\ .memo

\ } MemInfo_Library

: Misc_Library ; \ { ###############################################################


\ { Time ###############################################################

: time! ( hhmmss -- ) \ recalculate and set boot time
    HMS 60 * + 60 * + getms 1000 / - btime !
;

: time@ ( -- hhmmss )
    qtime@ ;

: time.
    qtime@ .
;

: date.
    bdate @ . ;

value oldvtime#
: vtd. \ print time and date to vga
    time@ oldvtime# <> if
        time@ to oldvtime#
        500 5 vxy vga date. time. emit;
    then
;

\ } TIME

: page ( -- ) ( { clear ANSI terminal page )
    27 emit 91 emit
    50 emit
    74 emit
    0 0 %XY
; ( } )


: %savePos \ save cursor position
    27 emit 55 emit ;

: %restorePos \ restore cursor position
    27 emit 56 emit ;

: ttd. \ print time and date to terminal
    time@ oldvtime# <> if
        time@ to oldvtime#
        %savePos
        80 0 %xy date. time. 
        %restorePos
    then
;


\ slow gettext gett.fth 
{ 
pre GETTEXT \ End: Euro or ESC
    [C] FOPEN
    @FILE 0= IF 
        1 MB MAKE file$ FOPEN$ 0EXIT 
    THEN
    0 BEGIN WKEY 
        DUP emit
        DUP $1B <> \ esc
        over 128 <> and \ Euro
    WHILE OVER SDC! 1+ 
    REPEAT
    DROP 0 SWAP SDC! FCLOSE
;
}


\ { fast gettext #####################################

\ fast variant of SAVETEXT for longer text, has to wait for SD-card
\ Usage: RW gettext file.fth This is the text ESC

$6c000 := textbuf \ space for 57k

: getbuf ( -- length )
    0 BEGIN WKEY 
        DUP emit
        DUP $1B <> \ esc
        over 128 <> and \ Euro
    WHILE 
        OVER textbuf + C! 1+ 
    REPEAT
    drop 
    0 over textbuf + C! 
    1+
;

: .buffer
    0
    crlf
    begin
        dup textbuf + c@
    dup while
        emit 1+
    repeat
    drop
    crlf . ." Bytes " crlf
;

long sdpause

pre GETTEXT \ Usage: RW gettext file.fth This is the text ESC
    [C] FOPEN
    @FILE 0= IF 
        1 MB MAKE file$ FOPEN$ 0EXIT 
    THEN   
    getbuf 
    sdpause ~
    ( length ) 0 do
        i textbuf + c@
        i sdc!
        sdpause dup ++ @ 510 > if sdpause ~ 2 ms then 
    loop
    FCLOSE
;


\ } fast gettext


\ { Heart Beat Polling ############################################################

: outsec \ copies time bit to pin 57 ( led of Kiss board )
    getms 9 >> 1 and 57 pin!
;
\ !polls \ clear polling tasks

\ ' outsec +poll \ funktioniert

\ } Polling
    
\ } Misc_Library 



: Dcf77_Library ; \ { ####################################################

\ Pollin DCF1 Module with positive pulses
\ http://endorphino.de/projects/electronics/timemanipulator/bilder/timemanipulator_dcf77code_01.gif

\ { Pins, Variables for Dcf77 

12 := dcfEnPin \ (enable=LOW on Pin 2 of module)
13 := dcfDataPin
57 := ledpin

ledpin float
dcfEnPin float

long secCnt# 
long bits#
long dbits#
long lasttime# 0 lasttime# ! 
long lastdate#
long lowtime# 
long hightime#   
long lastLowHigh# 
long lastHighLow#
long lastUpdateS# 1000 lastUpdateS# !
long dcfStatus#
long dcfDStatus#

\ } Pins and Variables


: >ONeg ( n1 n2 -- FLAG ) \ prevent stalling on overflow / midnight
    2DUP > \ n1 > n2 
    ROT ROT DROP 0< \ n1 negative
    OR ;
    
{
: dcfIn 
    dcfDataPin PIN@ IF ledpin HIGH ELSE ledpin LOW THEN ;
}

: dcfInit \ activate PON at module
    dcfEnPin HIGH
    300 ms
    dcfEnPin LOW
    0 lastLowHigh# !
    0 lastHighLow# !
;

\ Suppress short pulses
: waitLH
    BEGIN
        BEGIN dcfDataPin PIN@ 0 <> UNTIL 
    getms lastHighLow# @ - 30 >ONeg UNTIL
;

: waitHL
    BEGIN
        BEGIN dcfDataPin PIN@ 0 = UNTIL 
    getms lastLowHigh# @ - 30 >ONeg UNTIL
;

 
: dcfOntime ( -- ) 
    BEGIN dcfDataPin PIN@ 0 = UNTIL
    waitLH
        ledpin HIGH 
        getms 
        DUP lastLowHigh# @ - lowtime# !
        lastLowHigh# !
    waitHL
        ledpin LOW 
        getms
        DUP lastLowHigh# @ - hightime# !  
        lastHighLow# !
;

: dcfDecode \ long pulse, output format hh.mm.ss like time@
    secCnt# @ SWITCH
    21 CASE  100 bits# +! BREAK \ 1 minute
    22 CASE  200 bits# +! BREAK
    23 CASE  400 bits# +! BREAK
    24 CASE  800 bits# +! BREAK
    25 CASE 1000 bits# +! BREAK
    26 CASE 2000 bits# +! BREAK
    27 CASE 4000 bits# +! BREAK

    29 CASE  10000 bits# +! BREAK \ 1 hour
    30 CASE  20000 bits# +! BREAK
    31 CASE  40000 bits# +! BREAK
    32 CASE  80000 bits# +! BREAK
    33 CASE 100000 bits# +! BREAK
    34 CASE 200000 bits# +! BREAK
    
     36 CASE  1 dbits# +! BREAK \ 1 day
     37 CASE  2 dbits# +! BREAK   
     38 CASE  4 dbits# +! BREAK   
     39 CASE  8 dbits# +! BREAK
     40 CASE 10 dbits# +! BREAK   
     41 CASE 20 dbits# +! BREAK    

     45 CASE  100 dbits# +! BREAK \ 1 month
     46 CASE  200 dbits# +! BREAK      
     47 CASE  400 dbits# +! BREAK 
     48 CASE  800 dbits# +! BREAK 
     49 CASE 1000 dbits# +! BREAK

     50 CASE  10000 dbits# +! BREAK  \ 1 year
     51 CASE  20000 dbits# +! BREAK     
     52 CASE  40000 dbits# +! BREAK     
     53 CASE  80000 dbits# +! BREAK
     54 CASE 100000 dbits# +! BREAK   
     55 CASE 200000 dbits# +! BREAK     
     56 CASE 400000 dbits# +! BREAK
     57 CASE 800000 dbits# +! BREAK
;

: dcfGetBits 
    lowtime# @ 1500 > IF \ Minute completed
        0 secCnt# !
    ELSE
        hightime# @ 40 > IF
            secCnt# ++                
            hightime# @ 160 > IF dcfDecode THEN
        THEN
    THEN
;


: dcfSetTime \ Set the software clock of Tachyon after 2 consecutive receptions
    secCnt# @ 1 = IF
        lasttime# @ 100 + bits# @ = IF 
            bits# @ dup dcfStatus# ! time!
            0 lastLowHigh# !
            0 lastHighLow# ! 
            getms 1000 / lastUpdateS# ! 
            \ 10 ms crlf green PEN ." Time Set " 
        THEN 
        lastdate# @ dbits# @ = IF 
            dbits# @ dup dcfDStatus# ! bdate !
        THEN 
        bits# @ lasttime# ! 
        dbits# @ lastdate# !
        0 bits# ! 
        0 dbits# !
    THEN 
;  

{
: dcfShow \ For debugging 
    KEY DROP
    dcfInit
    BEGIN
        \ dcfIn
        dcfOntime        
        dcfGetBits
        crlf secCnt# @ DUP 1 = IF crlf %red %PEN THEN
        time@ . lasttime# @ . . lowtime# @ . hightime# @ . bits# @ .
        dcfSetTime
        %white %PEN
    KEY UNTIL 
; 
}

: dcfSet \ Task for a separate cog
    dcfInit
    0 dcfStatus# ! \ reset status
    0 dcfDStatus# !
    begin
        dcfOntime        
        dcfGetBits
        dcfSetTime
    dcfStatus# @ 0 <> dcfDStatus# @ 0 <> and until
    ledpin LOW
    ledpin float
    dcfEnPin float
;

\ } Dcf77_Library




8 BPP 360p !VGA 
VGA 'A' EMIT -mono emit;
vclr

' dcfSet 1 run

!polls
' vtd. +poll
\ ' ttd. +poll

