\ EggD.fth Taqoz V2.8
\ CWE 18.03.2022

{   


}

IFDEF *EggPaint*	
    \ 6 cogstop
    oldorg org
    FORGET *EggPaint*  }


pub *EggPaint*    PRINT" EggPaint EggD.fth" ;

0 bytes oldorg

!polls \ clear multitasking

--- { Pins, Variables 

--- VGA: first header 0-7

--- EggBot: second header 8-15


 8 := enableABPin 
 9 := dirAPin
10 := stepAPin
11 := dirBPin
12 := stepBPin
13 := servoPin \ pen lift

57 := dLedPin

dLedPin blink

50 value servoDown#
80 value servoUp#
250_000 value maxSpeed#
190 value pPc#
0 value offsetA#
0 value offsetB#

0 value actPosA#
0 value newPosA#
100_000 value speedA#
cnt@ value oldCntA#

0 value actPosB#
0 value newPosB#
100_000 value speedB#
cnt@ value oldCntB#

\ Var for Lemniscates
10_000 value lScale#
( 319_0000 ) 125_0000 value lA#    125_0000 value lB# \ 
1_5708 value lP#     16 value lS#
0 value lK#     0 value lL#

\ Var to control plot
0 value lQ#   0 value lN#   
0 value lXOld# 0 value lYOld#
0 value ePlotOn#


\ } Pins and Variables

: mechanics_Library ; \ { Blinker Heartbeat Stepper Servo ##############

dLedPin blink   1 hz

stepAPin low
dirAPin low
stepBPin low
dirBPin low
enableABPin high


\ dirAPin low stepAPin blink 100 hz \ test stepper A

{
: gotoA loc_a ( newPos -- ) \ uses pulses 
    a> .
    a> actPosA# - 
    dup 0 > if 
        dirAPin low 
    else 
        dirAPin high 
    then
    stepAPin pin
    30_000 dup hilo \ 3kHz
    abs pulses
    a> to actPosA#
endloc ;
}

: zSet 0 to actPosA#  0 to actPosB# ; 

: stepOff ( -- ) enableABPin high ;

: stepOn ( -- ) enableABPin low ;
    
: stepA ( -- )
    cnt@ oldCntA# - speedA# > if
        cnt@ to oldCntA#
        newPosA# actPosA# <> if
            newPosA# actPosA# > if
                dirAPin low 
                1 +to actPosA#
            else 
                dirAPin high   
                -1 +to actPosA#
            then
            stepAPin pin t \ toggle
        then
    then
;

: stepB ( -- )
    cnt@ oldCntB# - speedB# > if
        cnt@ to oldCntB#
        newPosB# actPosB# <> if
            newPosB# actPosB# > if
                dirBPin low 
                1 +to actPosB#
            else 
                dirBPin high   
                -1 +to actPosB#
            then
            stepBPin pin t \ toggle
        then
    then
;

: gtA ( newPos -- )
    to newPosA#
    cnt@ to oldCntA#
    begin
        stepA
    newPosA# actPosA# = until
;


: gtB ( newPos -- )
    to newPosB#
    cnt@ to oldCntB#
    begin
        stepB
    newPosB# actPosB# = until
;

: calcSpeed loc ( -- )
    newPosA# actPosA# - abs >a
    newPosB# actPosB# - abs >b
    a> b> > if
        maxSpeed# to speedA#
        b> 0 = if 1 >b then
        maxSpeed# a> b> */ to speedB#   
    else
        maxSpeed# to speedB#
        a> 0 = if 1 >a then
        maxSpeed# b> a> */ to speedA# 
    then
endloc ;
            
: gtAB ( newPosA newPosB -- )
    stepOn
    to newPosB#   to newPosA#
    calcSpeed
    cnt@ dup to oldCntA# to oldCntB#
    begin
        stepA   stepB
    newPosA# actPosA# =  newPosB# actPosB# = and until
;

: gtsAB ( newPosA newPosB -- ) \ use scale and offset
    swap 
    pPc# 100 */ offsetA# + 
    swap 
    pPc# 100 */ offsetB# +
    \ gtAB
    stepOn
    to newPosB#   to newPosA#
    calcSpeed
    cnt@ dup to oldCntA# to oldCntB#
    begin
        stepA   stepB
    newPosA# actPosA# =  newPosB# actPosB# = and until  
;
   

: wOff ( -- ) 100 ms stepOff ;
: gHome 0 0 gtAB wOff ;  
: gTop 6400 700 gtAB wOff ; 

: gServo ( pos% ) \ 1...2 ms pulse @ 50 Hz
    servoPin pin
    ( pos ) 100 + 2000 2000 pwm ( duty frame div ) ; 

: puS servoUp# gServo ;
: pdS servoDown# gServo ;

    


\ } mechanics_Library

: lemniscates ; \ { ###############################################

{
: line loc_a_b_c_d_e ( color x0 y0 x1 y1 )
    e> c> - abs   d> b> - abs < if \ steigung x ist groesser, x: fuehrt
        d> b> do
            a> i \ color and x 
            i b> - e> c> - d> b> - */ c> + plot
        d> b> > if 1 else -1 then +loop    
    else 

    then
endloc ;


: line loc_a_b_c_d_e ( color x0 y0 x1 y1 )
    e> c> - abs   d> b> - abs < if \ steigung x ist groesser, x: fuehrt
        b> d> > if b> d> >b >d then \ swap
        d> b> do
            a> i \ color and x 
            i b> - e> c> - d> b> - */ c> + plot
        loop    
    else 

    then
endloc ;
}

: line loc_a_b_c_d_e ( color x0 y0 x1 y1 ) \ draw line
    e> c> - abs   d> b> - abs < if \ steigung x ist groesser, x: fuehrt
        b> d> > if b> d> >b >d c> e> >c >e then \ swap
        d> b> do
            a> i 0 maxs 639 mins \ color and x 
            i b> - e> c> - d> b> - */ c> + 0 maxs 319 mins plot
        loop    
    else \ y fuehrt
        c> e> > if c> e> >c >e b> d> >b >d then \ swap
        e> c> do
            a> \ color
            i c> -   d> b> - e> c> - */ b> + 0 maxs 639 mins
            i 0 maxs 319 mins plot \ y 
        loop  
    then
endloc ;

: litest
    vclr 
    white 10 10 600 300 line 
    white 600 300 550 10 line  ;

\ https://www.classic-computers.org.nz/system-80/micro80/Micro-80-Volume-03-Issue-04-(1982)opt.pdf

{ \Literature
Here are some interesting number pairs to try for starters : 
1 , 1 33 ,1 1 00,1 2,3 2,5 5,10 1 00,100 667 , 667 250 , 250 
1 00 , .1 1 E-6 , 1 E -6 5,7

1 I =O : J =O : INPUT K,L:
    P= 1 . 57 : S= . 016: K=K*S: L=L*S: A=47 : B=23 : CLS : 
    FOR M= O TO P STEP S : 
        LET I = I +K : LET J =J+L : 
        LET Z=SQR < COS <M> > : LET X=Z * COS <I> *A: 
        LET Y = Z *S I N (J) *B: 
        SET < A+ X , B+Y > : SET < A- X , B+Y > : SET < A+ X , B-Y > : SET < A- X , B-Y > :
    NEXT: 
GOT0 1 :' LEMN I SCATES - Cl- K. SH I LLITO MAR 80 
}

\ white 300 300 plot \ to plot a point



: lPlot loc_a_b ( x y )
    white lA# a> + lScale# /   lB# b> + lScale# / plot \ SET < A+ X , B+Y > : 
    white lA# a> - lScale# /   lB# b> + lScale# / plot \ SET < A- X , B+Y > : 
    white lA# a> + lScale# /   lB# b> - lScale# / plot \ SET < A+ X , B-Y > : 
    white lA# a> - lScale# /   lB# b> - lScale# / plot \ SET < A- X , B-Y >   
endloc ;


: qPlot loc_a_b ( x y ) \ plot in quadrant
    lQ# switch 
    0 case white lA# a> + lScale# /   lB# b> + lScale# / plot endloc break \ SET < A+ X , B+Y > : 
    1 case white lA# a> - lScale# /   lB# b> + lScale# / plot endloc break \ SET < A- X , B+Y > : 
    2 case white lA# a> + lScale# /   lB# b> - lScale# / plot endloc break \ SET < A+ X , B-Y > : 
    3 case white lA# a> - lScale# /   lB# b> - lScale# / plot endloc break \ SET < A- X , B-Y >   
endloc ;

: lineto loc_a_b_c ( color xNew yNew ) \ with penplot option
    lN# if
        a> lXOld# lYOld#  b> c> line
        ePlotOn# if 
            b> lA# lScale# / -   
            c> lB# lScale# / - gtsAB 
        then 
    else
        ePlotOn# if 
            puS 500 ms
            b> lA# lScale# / -   
            c> lB# lScale# / - gtsAB 
            pdS 500 ms 
        then
    then
    1 +to lN#
    b> to lXOld#
    c> to lYOld#
endloc ;    

: square
    0 to lN#
    white 0 0 lineto
    white 0 1000 lineto
    white 1000 1000 lineto
    white 1000 0 lineto
    white 0 0 lineto
;

: qLine loc_a_b ( x y ) \ plot lines in quadrant
        lQ# switch 
        0 case white lA# a> + lScale# /   lB# b> + lScale# / 
            lineto endloc break \ SET < A+ X , B+Y > : 
        1 case white lA# a> - lScale# /   lB# b> + lScale# / 
            lineto endloc break \ SET < A- X , B+Y > : 
        2 case white lA# a> + lScale# /   lB# b> - lScale# / 
            lineto endloc break \ SET < A+ X , B-Y > : 
        3 case white lA# a> - lScale# /   lB# b> - lScale# / 
            lineto endloc break \ SET < A- X , B-Y >      
endloc ;


: cosk ( angle10000 -- cos10000 )
    2147483647 31416 */ >r
    0 10000 r> qrotate swap drop ;


: sink ( angle10000 -- cos10000 )
    1_5708 + cosk ;

: doLem loc_a_b ( K L )
    \ vclr
    0 to lN#
    0 >c \ I
    0 >d \ J
    a> lS# lScale# */ to lK# 
    b> lS# lScale# */ to lL# 
    
    lP# 0 do \ FOR M= O TO P STEP S : 
        c> lK# + >c \ LET I = I +K : 
        d> lL# + >d \ LET J =J+L : 
        i cosk  lScale# um* sqrt ( lScale# um* sqrt ) >e \ LET Z=SQR < COS <M> > : 
        \ lP# i - 2 / >e
        c> cosk lA# lScale# */ e> lScale# */ \ LET X=Z * COS <I> *A: X auf stack
        d> sink lB# lScale# */ e> lScale# */ \ LET Y = Z *S I N (J) *B: Y auf stack
        qLine ( x y -- ) 
    lS# +loop
endloc ;



: qLem loc_a_b ( K L )
    vclr
    4 0 do
        i to lQ#
        a> b> doLem
    loop
endloc ;

: endless ( -- )
    key drop
    begin
        crlf 
        rnd $7fff_ffff and 0 sqrt 7 * 2 / dup . 
        rnd $7fff_ffff and 0 sqrt 7 * 2 / dup .
        qLem
        500 ms
    
    key until
;


: single ( -- )
    crlf 
    rnd $7fff_ffff and 0 sqrt 7 * 2 / dup . 
    rnd $7fff_ffff and 0 sqrt 7 * 2 / dup .
    qLem
    500 ms
    puS
;

: lem12*3
    2 -1 do
        12 0 do
            crlf j . i .
            i 533 * j 177 * + to offsetA#
            j 533 * to offsetB#
            single
        loop
    loop
    500 ms gHome
;    
            
\ } lemniscates



€  